/* on recupere la hauteur du header affiche a l'ecran */
var triggerHeightDown, triggerHeightUp;
var log = false;

function traceLog(message, variable) {
	if (log) {
		console.log(message, variable);
	}
}

// permet de determiner si on est sur Safari (DSK+TAB+MOB)
function isSafari() {
	var ua = window.navigator.userAgent;
	traceLog("user agent", ua);
	var iOS = !!ua.match(/iP(ad|od|hone)/i);
	var Macintosh = !!ua.match(/Macintosh/i);
	var hasSafariInUa = !!ua.match(/Safari/i);
	var noOtherBrowsersInUa = !ua.match(/Chrome|CriOS|OPiOS|mercury|FxiOS|Firefox/i);
	var hasCriOS = !!ua.match(/CriOS/i);
	var result = false;
	var webkit = !!ua.match(/WebKit/i);
	if (iOS) { //detecting Safari in IOS mobile browsers
		if(webkit && hasCriOS) { // cas a partir de la version 16.3 qui integre CriOS dans son userAgent
			var v = ua.match(/OS (\d+)_(\d+)_?(\d+)?/);
			var versionMajeure = parseInt(v[1], 10);
			var versionMineure = parseInt(v[2], 10); 
			if (( versionMajeure > 16 ) || (( versionMajeure == 16 ) && ( versionMineure >= 3))) {
				result = true;
			}
		} else { // cas avant la 16.3
			result = webkit && hasSafariInUa && noOtherBrowsersInUa
		}
	} else if ((window.safari !== undefined) || (Macintosh && hasSafariInUa && webkit)) { //detecting Safari in Desktop Browsers
		result = true;
	} else { // detecting Safari in other platforms
		result = hasSafariInUa && noOtherBrowsersInUa
	}
	return result;
}

$(document).ready(function() {
	/* on récupère la hauteur du header affiché à l'écran */
	triggerHeightDown = $(".fixedview__banner:visible").height();
	triggerHeightUp = $(".fixedview__banner:visible").height();

	// affichage de la syndication globale de doc et suivi
	displayMainDocSyndication("navigation-documents", "nbDOC", false);
	
	// rustine affichage lien parapheur avec syndication en mode tablette
	addPatchVADLink();


	// calcul de la hauteur max possible pour le méga menu
	maxHeightMegaMenu();
	$(window).resize(function() {
		maxHeightMegaMenu();
	});

	switchHeader();
	$(document).scroll(function() {
		switchHeader();
	});

	/* POUR STYLER QUE TABULATION CLAVIER */
	var allowTabFocus = false;
	$(window).on('keydown', function(e) {
		if(e.keyCode !== 32 && e.keyCode !== 13 && e.keyCode != 27){ // ECHAP, entrée et espace n'enlève pas le focus de l'élément sélectionné
			$('header *').removeClass('focus-visible');
		}
		if (e.keyCode === 9) {
			allowTabFocus = true;
		}
	});

	$('header *').on('focus', function() {
		if (allowTabFocus) {
			$(this).addClass('focus-visible');
		}
	});

	$(window).on('mousedown', function() {
		$('header *').removeClass('focus-visible');
		allowTabFocus = false;
	})
	/* POUR STYLER QUE TABULATION CLAVIER ***** FIN */

	// on teste le contenu de la zone edito du menu.
	// si celle-ci est vide (prod) ou contient le texte du bloc rose (R7), on supprime la zone pour que le menu s'étale
	// + ajout d'une classe sur les sous-menu qui ont un bloc edito pour modifier les marges entre les blocs
	if ($(".nav-panel-content-edito").length > 0) {
		$(".nav-panel-content-edito").each(function() {
			var currentBlock = $(this);
			var contentTest = $(this).find("div > div").html();
			var maRegex = /Bloc editorial absent du cache/;
			var tab = maRegex.exec(contentTest);
			if (contentTest == "" || maRegex.exec(contentTest) !== null) {
				currentBlock.remove();
			} else {
				// pour cibler tous les mega menus SAUF notre offre qui a un agencement specifique
				if (this.tagName == "DIV") {
					currentBlock.parents(".nav-panel-content").find(".nav-panel-content-menu").addClass("with-edito");
				}
			}
		});
	}

	// menu Mon profil
	if ($(".collapse-profile").length > 0 || $(".collapse-contact").length > 0) {

		// fermer les menus quand on clique ailleurs
		$(document).click(function(e) {
			var x = document.activeElement.tagName;
			traceLog("active element", x);
			if (x == "BODY") {
				var testSafari = isSafari();
				traceLog("isSafari", testSafari);
				traceLog("event click doc : ", e.type);
				if (!testSafari) {
					hideProfile();
					hideContact();
					//closeAllMainNav(); un peu trop efficace...
				}
			}

		});
		
		// fermer le menu quand on focus sur le bouton deconnexion
		$(".deconnexion-btn").focus(function() {
			hideProfile();
			hideContact();
		});
		
		var contactBtn = $(".collapse-contact__btn");
		var profileBtn = $(".collapse-profile__btn");
		// fermer le menu sur la touche ECHAP
		$(document).keydown(function(e) {
			if (e.keyCode == 27) { // touche ECHAP
				if(profileBtn[0].ariaExpanded == 'true'){
					hideProfile();
					profileBtn.addClass('focus-visible');
				}
				if(contactBtn[0].ariaExpanded == 'true'){
					hideContact();
					contactBtn.addClass('focus-visible');

				}
			}
		});
	}
	
	if ($(".collapse-profile").length > 0) {

		// au clic sur le bouton, on affiche/masque le menu
		$(document).on('click', '.profile__delayClose #collapse-profile__btn', function() {
			closeAllMainNav(); // on ferme le menu de navigation au cas où
			hideContact(); // on ferme le menu contact au cas où
			displayProfile(); // on affiche le menu mon profil
			traceLog("event click profile : ", event.type);
			event.stopPropagation(); // on empêche l'event de remonter dans le dom

			// desactivation du tag qui bloque l'ouverture sur Safari en attendant de regler le probleme
			return tc_events_8(this, 'CLICK', { 'clic_s2': '16', 'clic_label': 'Profil', 'clic_type': 'N' });
		});
		$(document).on('click', '.profile__delayOpen #collapse-profile__btn', function() {
			closeAllMainNav(); // on ferme le menu de navigation au cas où
			hideContact(); // on ferme le menu contact au cas où
			hideProfile(); // on masque le menu mon profil
		});
		
		// fermer le menu quand on focus sur le bouton contact
		$("#collapse-profile__btn").focus(function() {
			hideContact();
		});
		
	}
	
	if ($(".collapse-contact").length > 0) {
		
		// au clic sur le bouton, on affiche/masque le menu
		$(document).on('click', '.contact__delayClose #collapse-contact__btn', function() {
			closeAllMainNav(); // on ferme le menu de navigation au cas où
			hideProfile(); // on ferme le menu mon profil au cas où
			displayContact(); // on affiche le menu Contact
			traceLog("event click contact : ", event.type);
			event.stopPropagation(); // on empêche l'event de remonter dans le dom

			// desactivation du tag qui bloque l'ouverture sur Safari en attendant de regler le probleme
			return tc_events_8(this, 'CLICK', { 'clic_s2': '16', 'clic_label': 'Contacts', 'clic_type': 'N' });
		});
		$(document).on('click', '.contact__delayOpen #collapse-contact__btn', function() {
			closeAllMainNav(); // on ferme le menu de navigation au cas où
			hideContact(); // on ferme le menu contact au cas où
			hideProfile(); // on masque le menu mon profil
		});
		
		// fermer le menu quand on focus sur le bouton profile
		$("#collapse-contact__btn").focus(function() {
			hideProfile();
		});
		
		$(".header-main-dsk .header__logo a, .header-main-dsk .emergency-link").focus(function() {
			hideContact();
		});
		
	}

	if ($("#menuPrincipalNavigation").length > 0) {
		$("#menuPrincipalNavigation .item-nav").on('click', function() {
			hideProfile(); // on ferme le menu mon profil au cas où
			displaySubMenuDSK($(this));
		});
		// quand on focus un item de niveau 1, si ce n'est pas son propre menu qui est ouvert, on ferme les autres
		$("#menuPrincipalNavigation .item-nav").on('focus', function() {
			var button = $(this);
			var currentLvl1 = button.parent();
			if (!currentLvl1.hasClass("nav-panel__open")) {
				closeAllMainNav();
			}
		});
		// pour pouvoir fermer le dernier menu en tabulation
		$("#main button, #main a").on('focus', function() {
			closeAllMainNav();
		});
	}
	
	/* -------------------------------------------------- */
	// menu deroulant Mes Pass
	if ($(".collapse-pass").length > 0) {
		
		// fermer les menus quand on clique ailleurs
		$(document).click(function(e) {
			var x = document.activeElement.tagName;
			traceLog("active element", x);
			if (x == "BODY") {
				var testSafari = isSafari();
				traceLog("isSafari", testSafari);
				traceLog("event click doc : ", e.type);
				if (!testSafari) {
					hidePass();
					//closeAllMainNav(); un peu trop efficace...
				}
			}

		});

		// au clic sur le bouton, on affiche/masque le menu Mes Pass
		$(document).on('click', '.pass__delayClose #collapse-pass__btn', function() {
			closeAllMainNav(); // on ferme le menu de navigation au cas où
			displayPass(); // on affiche le menu Mes Pass
			traceLog("event click pass : ", event.type);
			event.stopPropagation(); // on empêche l'event de remonter dans le dom
		});
		
		$(document).on('click', '.pass__delayOpen #collapse-pass__btn', function() {
			closeAllMainNav(); // on ferme le menu de navigation au cas où
			hidePass(); // on masque le menu Mes Pass
		});		
		
		$(document).on('click', '.ico-pass-jeune', function() {
			hidePass(); // on masque le menu Mes Pass au clic sur le bouton Pass Jeune (ouverture d'une nouvelle fenetre)
		});
		
		// fermer le menu quand on focus sur les éléments avant ou apres
		$(".subnav__link:first-of-type, .item-nav.offre").focus(function() {
			hidePass();
		});


		// fermer le menu sur la touche ECHAP
		$(document).keydown(function(e) {
			if (e.keyCode == 27) { // touche ECHAP
				hidePass();
			}
		});

	}

});

/** Affichage mega menu DSK/TAB sur hauteur trop petite, on verrouille la taille du méga menu à la hauteur max dispo par l'écran */
function maxHeightMegaMenu() {
	var windowH = $(window).height();
	var headerH = $("#header-main.header-main-dsk").height();
	var megaMenuH = windowH - headerH;
	$("#header-main.header-main-dsk .nav-panel").css("max-height", megaMenuH + "px");
}

/** fonction pour afficher le menu profil
 */
function displayProfile() {
	var target = $('.collapse-profile');
	var menu = target.find('.collapse-profile__nav');
	var button = $('#collapse-profile__btn');
	traceLog("j'ouvre le menu Profile", "");
	target.addClass("collapse-profile__open").removeClass("collapse-profile__close");
	button.attr("aria-expanded", true);
	menu.attr("aria-hidden", false);
	menu.find("a").attr("tabindex", "0");
	//menu.find("a").eq(0).focus();

	// on a un probleme de double clic sur Safari
	// les classes delayClose/Open actionnent le trigger et on les change au bout d'une demi seconde pour ne pas empêcher l'ouverture du menu
	setTimeout(function() {
		target.addClass("profile__delayOpen").removeClass("profile__delayClose");
		traceLog("je switch la classe => profile__delayOpen");
	}, 500);
}
/** fonction pour masquer le menu profil
 */
function hideProfile() {
	var target = $('.collapse-profile');
	if (target.hasClass("collapse-profile__open")) {
		var menu = target.find('.collapse-profile__nav');
		var button = $('#collapse-profile__btn');
		traceLog("je ferme le menu Profile", "");
		target.removeClass("collapse-profile__open").addClass("collapse-profile__close");
		button.attr("aria-expanded", false);
		menu.attr("aria-hidden", true);
		menu.find("a").attr("tabindex", "-1");

		// on a un probleme de double clic sur Safari
		// les classes delayClose/Open actionnent le trigger et on les change au bout d'une demi seconde pour ne pas empêcher l'ouverture du menu
		setTimeout(function() {
			target.addClass("profile__delayClose").removeClass("profile__delayOpen");
			traceLog("je switch la classe => profile__delayClose", "");
		}, 500);
	}
}

/**
 * Gestion de l'affichage des syndications "globales" qui encapsule les syndications messages + doc + signature
 *
 * @param idMenu : id du menu cible : DSK ou MOB
 * @param idSyndic : id syndication cible DSK ou MOB
 * @param mobile : booleen pour savoir si on est pour la version DSK ou MOB
 * @returns
 */
function displayMainDocSyndication(idMenu, idSyndic, mobile) {
	var activeSyndications = $("#" + idMenu + " .syndic");
	var accessTxtDemandes = "document(s) à consulter";
	var total = 0;
	for (var i = 0; i < activeSyndications.length; i++) {
		traceLog($(activeSyndications[i]).text(), "");
		total += parseInt($(activeSyndications[i]).text());
	}
	traceLog("total doc",total);
	
	if (total > 0) {
		$("#" + idSyndic).text(total).removeClass("nodisplay");
		$("#" + idSyndic + " + .sr-only").text(accessTxtDemandes);
		$("#globalHUB").removeClass("nodisplay").removeAttr("aria-hidden");
		if (mobile) {
			$("#textHub").append(" / " + total + " " + accessTxtDemandes);
		}
	}
}

function displaySubMenuDSK(button) {
	hideProfile(); // on ferme le menu mon profil au cas où
	var currentLvl1 = button.parent();
	if (currentLvl1.hasClass("nav-panel__open")) {
		closeCurrentMainNav(button);
	} else {
		closeAllMainNav();
		openCurrentMainNav(button);
	}
}

/** ouvre le sous-menu courant */
function openCurrentMainNav(currentBtn) {
	var currentLvl1 = currentBtn.parent();
	var currentLvl2 = currentLvl1.find(".nav-panel");
	if (currentLvl2.length > 0) {
		currentLvl1.addClass("nav-panel__open");
		currentBtn.attr("aria-expanded", true);
		currentLvl2.attr("aria-hidden", false);
		currentLvl2.find("a").attr("tabindex", "0");

		// gestion du grisé qui bloque le reste de la page
		$("#header-main").after("<div id='blocker-menu'></div>");
		var hauteurHeader = $("#header-main").height();
		$("#blocker-menu").css("top", hauteurHeader + "px");
		$("#blocker-menu").click(function() {
			closeAllMainNav();
		});
		// sur la touche ECHAP, on ferme les sous menus
		$(document).keydown(function(e) {
			const isExpand = currentBtn.context.ariaExpanded ?? 'false' ;
			if (e.keyCode == 27 && isExpand == "true") { // touche ECHAP et panel ouvert
				closeAllMainNav();
				// on replace le focus sur le menu niveau 1 déclencheur
				currentBtn.focus();
				currentBtn.addClass('focus-visible');
			}
		});
	}

	if (!currentBtn.hasClass("active")) {
		$("#menuPrincipalNavigation > li > .active").addClass("no-underline");
	}
}
/** ferme juste le menu courant actuellement ouvert */
function closeCurrentMainNav(currentBtn) {
	var currentLvl1 = currentBtn.parent();
	var currentLvl2 = currentLvl1.find(".nav-panel");

	currentLvl1.removeClass("nav-panel__open");
	currentBtn.attr("aria-expanded", false);
	currentLvl2.attr("aria-hidden", true);
	currentLvl2.find("a").attr("tabindex", "-1");
	$("#blocker-menu").remove();

	$("#menuPrincipalNavigation > li > .active").removeClass("no-underline");
}

/** ferme tous les menus potentiellement ouverts */
function closeAllMainNav() {
	var allMenus = $("#menuPrincipalNavigation > li");
	var btns = $("#menuPrincipalNavigation button.item-nav");
	var panels = $("#menuPrincipalNavigation .nav-panel");

	allMenus.removeClass("nav-panel__open");
	btns.attr("aria-expanded", false);
	panels.attr("aria-hidden", true);
	panels.find("a").attr("tabindex", "-1");
	$("#blocker-menu").remove();

	$("#menuPrincipalNavigation > li > .active").removeClass("no-underline");
}

function switchHeader() {
	// Recuperation de la position du scroll
	var scrollPos = $(document).scrollTop();
	if ((scrollPos >= triggerHeightDown)) {
		$(".fixedview__banner").hasClass("fixed") ? "" : $(".fixedview__banner").addClass("fixed");
		triggerHeightUp = $(".fixedview__banner.fixed:visible").height();

		if ($(".header-band").hasClass("fixed")) {
			$(".header-band.fixed .header_sub_nav_zone").attr("aria-hidden", true);
			$(".header-band.fixed .header__nav .logout").removeAttr("aria-hidden");
		}
	} else if ((scrollPos < triggerHeightUp)) {
		$(".fixedview__banner").removeClass("fixed");
		$(".header-band .header_sub_nav_zone").removeAttr("aria-hidden");
		$(".header-band .header__nav .logout").attr("aria-hidden", true);
	}

	if ($("#blocker-menu").length) {
		var hauteurHeader = $("#header-main").height();
		$("#blocker-menu").css("top", hauteurHeader + "px");
	}
}

/** fonction pour afficher le menu deroulant Mes Pass
 */
function displayPass() {
	var target = $('.collapse-pass');
	var menu = target.find('.collapse-pass__nav');
	var button = $('#collapse-pass__btn');
	traceLog("j'ouvre le menu Mes Pass", "");
	target.addClass("collapse-pass__open").removeClass("collapse-pass__close");
	button.attr("aria-expanded", true);
	menu.attr("aria-hidden", false);
	menu.find("a").attr("tabindex", "0");

	// on a un probleme de double clic sur Safari
	// les classes delayClose/Open actionnent le trigger et on les change au bout d'une demi seconde pour ne pas empêcher l'ouverture du menu
	setTimeout(function() {
		target.addClass("pass__delayOpen").removeClass("pass__delayClose");
		traceLog("je switch la classe => pass__delayOpen");
	}, 500);
}

/** fonction pour masquer le menu deroulant Mes Pass
 */
function hidePass() {
	var target = $('.collapse-pass');
	if (target.hasClass("collapse-pass__open")) {
		var menu = target.find('.collapse-pass__nav');
		var button = $('#collapse-pass__btn');
		traceLog("je ferme le menu Mes Pass", "");
		target.removeClass("collapse-pass__open").addClass("collapse-pass__close");
		button.attr("aria-expanded", false);
		menu.attr("aria-hidden", true);
		menu.find("a").attr("tabindex", "-1");
		// on a un probleme de double clic sur Safari
		// les classes delayClose/Open actionnent le trigger et on les change au bout d'une demi seconde pour ne pas empêcher l'ouverture du menu
		setTimeout(function() {
			target.addClass("pass__delayClose").removeClass("pass__delayOpen");
			traceLog("je switch la classe => pass__delayClose", "");
		}, 500);
	}
}



/** fonction pour afficher le menu deroulant Contacts
 */
function displayContact() {
	var target = $('.collapse-contact');
	var menu = target.find('.collapse-contact__nav');
	var button = $('#collapse-contact__btn');
	traceLog("j'ouvre le menu Mes contacts", "");
	target.addClass("collapse-contact__open").removeClass("collapse-contact__close");
	button.attr("aria-expanded", true);
	menu.attr("aria-hidden", false);
	menu.find("a").attr("tabindex", "0");

	// on a un probleme de double clic sur Safari
	// les classes delayClose/Open actionnent le trigger et on les change au bout d'une demi seconde pour ne pas empêcher l'ouverture du menu
	setTimeout(function() {
		target.addClass("contact__delayOpen").removeClass("contact__delayClose");
		traceLog("je switch la classe => contact__delayOpen");
	}, 500);
}
/** fonction pour masquer le menu deroulant Contacts
 */
function hideContact() {
	var target = $('.collapse-contact');
	if (target.hasClass("collapse-contact__open")) {
		var menu = target.find('.collapse-contact__nav');
		var button = $('#collapse-contact__btn');
		traceLog("je ferme le menu Mes contact", "");
		target.removeClass("collapse-contact__open").addClass("collapse-contact__close");
		button.attr("aria-expanded", false);
		menu.attr("aria-hidden", true);
		menu.find("a").attr("tabindex", "-1");

		// on a un probleme de double clic sur Safari
		// les classes delayClose/Open actionnent le trigger et on les change au bout d'une demi seconde pour ne pas empêcher l'ouverture du menu
		setTimeout(function() {
			target.addClass("contact__delayClose").removeClass("contact__delayOpen");
			traceLog("je switch la classe => contact__delayClose", "");
		}, 500);
	}
}

function addPatchVADLink(){
	$("#navigation-documents a").each(function() {
			var currentLink = $(this);
			var currentUrl = $(this).attr("href");
			var maRegex = /parapheur/;
			var isParapheur = maRegex.test(currentUrl);
			if (isParapheur) {
				var syndication = currentLink.find(".syndic");
				traceLog("isParapheur", syndication.length);
				if (syndication.length > 0) {
					currentLink.addClass("lien-parapheur");
				}
			}
		});
}

