$(document).ready(function() {

	// Menu principal
	$('#menu-calque').click(onMenuClick);
	
	// Menu Mon profil
	$('#profile-menu-calque, #menu-profile__btn').click(function(){
		// on gere le menu mobile
		onProfileClick();
	});

	$('#menu-mobile-main .nav-level-1 > li > button.item-nav, #menu-mobile-main .nav-annexe > li > button.item-nav').click(function(){
		// on gere le menu mobile
		showSubMenu($(this));
		
	});
	$('#menu-mobile-main .nav-panel button.mobile-back-btn').click(function(){
		// on gere le menu mobile
		hideSubMenu($(this));
		/*
		// on traite aussi le menu DSK en background en cas de switch mode MOB/TAB
		closeAllMainNav();
		*/
	});

	// MENU BLEU pour l'ancienne charte. à conserver tant que les 2 chartes coexistent
    var coll = document.getElementsByClassName("collapsible");
    var i;

    for (i = 0; i < coll.length; i++) {
        coll[i].addEventListener("click", function() {
            this.classList.toggle("active");
            this.parentNode.classList.toggle('active');
            var content = this.nextElementSibling;

            if (content.style.maxHeight){
                content.style.maxHeight = null;
                content.style.visibility = "hidden";
                content.setAttribute('aria-hidden', 'true');
            } else {
                content.style.maxHeight = content.scrollHeight + "px";
                content.style.visibility = "visible";
                content.setAttribute('aria-hidden', 'false');
            }

        });
    }

});
	
// masque l'element en mode swipe
function hideElement(e,maxTab) {
    e.css('visibility', 'hidden');
    var largeur = "580px";
    if(maxTab){
    	largeur = $(window).width()+"px";
    } 
    //console.log("maxTab",largeur);
    e.css('transform', 'translateX(-'+largeur+')'); 
    e.attr('aria-hidden', 'true');
}
// affiche l'element en mode swipe
function showElement(e) {
	e.attr('aria-hidden', 'false');
    e.css('visibility', 'visible');
    e.css('transform', 'translateX(0)');
}

function showMenu(menuID, labelBtn) {

    // Afficher le menu
	// /!\ ne pas découper en fonctions indépendantes car ça casse la mise en focus du 1er item (bloquant) o_O
	showElement($('#menu-mobile-body'));
    var mainMenu = $('#menu-mobile-main');
    var profileMenu = $('#menu-mobile-profile');
    if (menuID === 'menu-mobile-main') {
    	profileMenu.addClass("nodisplay");
    	profileMenu.attr("aria-hidden",true);
    	profileMenu.find('.item-nav').attr("tabindex",-1);
    	mainMenu.removeClass("nodisplay");
        mainMenu.attr("aria-hidden",false);
        mainMenu.find('.item-nav').attr("tabindex",0);
        // besoin du settimeout pour que le focus soit operationnel (don't ask me why...)
    	setTimeout(function(){
    		mainMenu.find('.item-nav').eq(0).focus();
			labelBtn.text("Fermer le menu principal de navigation");
    	},100);
    } else {
    	mainMenu.addClass("nodisplay");
    	mainMenu.attr("aria-hidden",true);
    	mainMenu.find('.item-nav').attr("tabindex",-1);
        profileMenu.removeClass("nodisplay");
        profileMenu.attr("aria-hidden",false);
        profileMenu.find('.item-nav').attr("tabindex",0);
        // besoin du settimeout pour que le focus soit operationnel (don't ask me why...)
    	setTimeout(function(){
    		profileMenu.find('.item-nav').eq(0).focus();
			labelBtn.text("Fermer le menu");
    	},100);
    }
}

function hideMenu() {
	var currentWidth = $(window).width();
	if(currentWidth > 580){
		hideElement($('#menu-mobile-body'), true);
	} else {
		hideElement($('#menu-mobile-body'), false);
	}
    $('#menu-mobile-body .item-nav').attr("tabindex",-1);
}

/** on affiche le sous menu courant
 * 
 * @param boutonCourant : bouton qui active l'ouverture du menu
 * @returns void
 */
function showSubMenu(boutonCourant) {
	var menu = boutonCourant.parent().find(".nav-panel");
	// on bloque l'acces aux autres items de niveau 1
	var itemsNiv1 = boutonCourant.parents("#menu-mobile-main").find(".item-nav");
	itemsNiv1.each(function() { 
		$(this).attr("tabindex",-1);
		$(this).attr("aria-hidden",true);
	});
	// preparation de l'accessibilite du sous menu courant
	boutonCourant.attr("aria-expanded",true);
	menu.attr("aria-hidden",false);
	//console.log("showSubMenu menu :",menu);
	menu.find('.nav-level-3 a').each(function() { 
		$(this).attr("tabindex",0);
	});
	menu.attr("tabindex",-1); // a cause de FF
	
	// Afficher le menu
	showElement(menu);
	
	//trapFocusMenu(document.getElementById(menu.attr("id")));
	
	// besoin du settimeout pour que le focus soit operationnel (don't ask me why...)
	setTimeout(function(){
		menu.find(".mobile-back-btn").focus();
	},100);
}
/** on masque le sous menu courant
 * 
 * @param boutonCourant : bouton qui active l'ouverture du menu
 * @returns void
 */
function hideSubMenu(boutonCourant) {
	var menu = boutonCourant.parents(".nav-panel");
	var btnNiv1 = menu.parents('li').find(".item-nav");
	
	// on redonne l'acces aux autres items de niveau 1
	var itemsNiv1 = boutonCourant.parents(".nav-level-1").find(".item-nav");
	itemsNiv1.each(function() { 
		$(this).attr("tabindex",0);
		$(this).attr("aria-hidden",false);
	});
	// preparation de l'accessibilite
	btnNiv1.attr("aria-expanded",false);
	menu.attr("aria-hidden",true);
	menu.find('.nav-level-3 a').each(function() { 
		$(this).attr("tabindex",-1);
	});
	// Masquer le menu
	var currentWidth = $(window).width();
	if(currentWidth > 580){
		hideElement(menu, true);
	} else {
		hideElement(menu, false);
	}
	// besoin du settimeout pour que le focus soit operationnel (don't ask me why...)
	setTimeout(function(){
		btnNiv1.focus();
	},100);
}

function onMenuClick() {
    var menuBtn = $('#menu-calque');
    var menuIcon = menuBtn.find('.burger');
	var menuLabelBtn = menuBtn.find('.label-access');

    if (!menuBtn.hasClass("close")) {
    	// on check si le menu Mon profil n'est pas déjà ouvert :
    	var profileBtn = $('#menu-profile__btn');
    	if (profileBtn.hasClass("menu-profile__open")) {
    		profileBtn.removeClass('menu-profile__open');
    		profileBtn.find('.label-access').text("Ouvrir le menu");
            hideMenu();
	    	setTimeout(function(){
	    		showMenu('menu-mobile-main', menuLabelBtn);
	    		menuBtn.addClass('close');
	    	}, 500);
    		
    	} else {
    		// Afficher le menu et l'icone delete
    		menuBtn.addClass('close');
    		$('.last_connexion').addClass('nodisplay');
    		showMenu('menu-mobile-main', menuLabelBtn);
    		$('body').addClass('noscroll modeMobile');
			$("#menuAccessibilite").addClass("nodisplay");
    		function hideMain() {
    			$('#main, #main-footer').addClass('nodisplay');
    			$('#main, #main-footer').addClass('displayingMenu');
    			// deplace ici cause du couple nvda/ff qui le vocalise trop tot sinon :
    			menuLabelBtn.text("Fermer le menu principal de navigation");
    		}
    		setTimeout(hideMain, 500);
    	}

    } else {
        // Cacher le menu et reafficher le burger
    	menuBtn.removeClass('close');
    	menuLabelBtn.text("Ouvrir le menu principal de navigation");
		hideMenu();
		var subMenuOpen = $("#menuPrincipalNavigationMobile .nav-panel[aria-hidden=false]");
		if (subMenuOpen.length > 0){
			hideSubMenu(subMenuOpen.find(".mobile-back-btn"));
		}
		$('body').removeClass('noscroll modeMobile');
      	$('#main, #main-footer, #menuAccessibilite').removeClass('nodisplay');
		$('#main, #main-footer').removeClass('displayingMenu');
      	function displayLastConnexion() {
			$('.last_connexion').removeClass('nodisplay');
		}
		setTimeout(displayLastConnexion, 500);
    }
}

function onProfileClick() {

    var profileBtn = $('#menu-profile__btn');
	var profilLabelBtn = profileBtn.find('.label-access');

    if (!profileBtn.hasClass("menu-profile__open")) {
    	// on check si le menu normal n'est pas déjà ouvert :
    	var menuBtn = $('#menu-calque');
    	if (menuBtn.hasClass("close")) {
	    	menuBtn.removeClass('close');
	    	menuBtn.find('.label-access').text("Ouvrir le menu principal de navigation");
	    	hideMenu();
	        var subMenuOpen = $("#menuPrincipalNavigationMobile .nav-panel[aria-hidden=false]");
	        if (subMenuOpen.length > 0){
	        	hideSubMenu(subMenuOpen.find(".mobile-back-btn"));
	        }
	    	setTimeout(function(){
	    		showMenu('menu-mobile-profile', profilLabelBtn);
	    		profileBtn.addClass('menu-profile__open');
	    	}, 500);
    	} else {
    		profileBtn.addClass('menu-profile__open');
    		$('.last_connexion').addClass('nodisplay');
    		showMenu('menu-mobile-profile', profilLabelBtn);
    		$('body').addClass('noscroll modeMobile');
			$("#menuAccessibilite").addClass("nodisplay");
    		function hideMain() {
    			$('#main, #main-footer').addClass('nodisplay');
    		}
    		setTimeout(hideMain, 500);
    	}
    	
    	
    } else {
    	profileBtn.removeClass('menu-profile__open');
    	profilLabelBtn.text("Ouvrir le menu");
    	hideMenu();
        $('body').removeClass('noscroll modeMobile');
        $('.last_connexion, #main, #main-footer, #menuAccessibilite').removeClass('nodisplay');
    }
}

//permet de rendre la tabulation hermétique dans le menu (désactivé suite au JIRA LBPBP-3502)
function trapFocusMenu(element) {
	var focusableEls = element.querySelectorAll('a[href]:not([disabled]), button:not([disabled]), textarea:not([disabled]), input[type="text"]:not([disabled]), input[type="radio"]:not([disabled]), input[type="checkbox"]:not([disabled]), select:not([disabled])');
	var firstFocusableEl = focusableEls[0];  
	var lastFocusableEl = focusableEls[focusableEls.length - 1];
	var KEYCODE_TAB = 9;
	
	element.addEventListener('keydown', function(e) {
	  var isTabPressed = (e.key === 'Tab' || e.keyCode === KEYCODE_TAB);
	
	  if (!isTabPressed) { 
	    return; 
	  }
	
	  if ( e.shiftKey ) /* shift + tab */ {
	    if (document.activeElement === firstFocusableEl) {
	      lastFocusableEl.focus();
	        e.preventDefault();
	      }
	    } else /* tab */ {
	    if (document.activeElement === lastFocusableEl) {
	      firstFocusableEl.focus();
	        e.preventDefault();
	      }
	    }
	});
}

