$(document).ready(function() {
	// ajout des aria-required true par JS (car les composants ADMC ne les gèrent pas)
	var required = $(".add-required");
	required.each(function( index ) {
	$(this).attr("aria-required",true);
	});
	// ajout des aria-disabled true par JS (car les composants ADMC ne les gèrent pas)
	required = $(".add-disabled");
	required.each(function( index ) {
	$(this).attr("aria-disabled",true);
	});
	// ACCESSIBILITE QUAND ON A BESOIN DE REPRODUIRE LE COMPORTEMENT D'UN <A HREF> SUR UN <BUTTON>
	if($(".button-link").length > 0 ) {
		$(".button-link").click(function(){
			var location = $(this).data("href");
			window.location = location;
		});
	}
	// ACCESSIBILITE QUAND ON A BESOIN DE REPRODUIRE LE COMPORTEMENT D'UN <A HREF> SUR UN <BUTTON>
	if($("a[role=button]").length > 0 ) {
		$("a[role=button]").focus(function(){
			// on active le href aussi sur la barre d'espace
			var location = $(this).attr("href");
			$(document).keydown(function(e) { 
				console.log("keyCode",e.keyCode);
				if (e.keyCode == 32) { // touche spaceBar
					window.location = location;
				}
			});
		});
	}
});

function formatteMontant(chaine){
	var chaineOut = "";
	var reg = /^-?\d*\.?\d*$/; // pour vérifier qu'on n'a que des nombres
	
	if (reg.test(chaine)) {
		var chaineSplit = chaine.split(".");
		var chaineEuro = chaineSplit[0];
		var chaineCts = chaineSplit[1];
		if (chaineSplit.length == 1){
			if (chaine == "0") {
				chaineOut = "0.00";
			} else {
				chaineOut = chaine + "." + "00";
			}
		}else if (chaineCts.length == 1){
			chaineOut = chaineEuro + "." + chaineCts + "0";
		} else{
			chaineOut = chaineEuro + "." + chaineCts;
		}
	} else {
		chaineOut = chaine;
	}
	return chaineOut; 
}

function point(chaine) {
	var i;
	var chaineOut;
	i = chaine.indexOf(",");
	if (i == -1) {
		chaineOut = chaine;
	} else {
		chaineOut = chaine.substring(0, i) + "." + chaine.substring(i+1, chaine.length);
	}
	return(chaineOut);
}



function GetDate (id, reg, str) {
	if (str.length == 10) {
		var tableau = str.split(reg);
		if  ((tableau[0].length == 2) && (tableau[1].length == 2) && (tableau[2].length == 4)) {
	  		return tableau[id];
		} 
	}
	return NaN;
}

/* TODO basculer vers la methode displayErrorMessageWithAccess() des que le metier accepte de payer l'evolution pour la gestion des champs des recherches */
function displayErrorMessage(msg){
	var errorMsg = "<p class='error-message --error'><i aria-hidden=\"true\" class=\"icon-ic_notification_error --error\"></i>";
	errorMsg += msg + "</p>";
	return errorMsg;
}

function displayErrorMessageWithAccess(msg, idMsg){
	var errorMsg = "<p class='error-message --error' id='" + idMsg + "'><i aria-hidden=\"true\" class=\"icon-ic_notification_error --error\"></i>";
	errorMsg += msg + "</p>";
	return errorMsg;
}
function displayErrorGlobalMessage(msg){
	var errorMsg = "<div class='error-global-message block2020'><i aria-hidden=\"true\" class=\"icon-ic_notification_alerte --error\"></i>";
	errorMsg += msg + "</div>";
	return errorMsg;
}
function displayErrorListMessages(msg){
	var errorMsg = "<div class='error-global-list-message block2020'><i aria-hidden=\"true\" class=\"icon-ic_notification_error --error\"></i><div>";
	errorMsg += msg + "</div></div>";
	return errorMsg;
}
/**
 * Construction de la liste (accessible) des messages d'erreur sous forme d'une liste à part (pour Prélèvements)
 * 
 * @param msgTab : tableau d'objet de 2 paramètres : sélecteur du champ visé + message d'erreur associé
 * @returns string des messages d'erreur avec construction DOM
 */
function prepareListingError(msgTab){
	// à chaque nouvelle validation, on reinitialise les attributs aria avant de les renseigner de nouveau
	for (var i = 0; i < msgTab.length; i++){
		$("input, select").removeAttr("aria-describedby");
		$("input, select").removeAttr("aria-invalid");
	}
	// hop, mise à jour des messages, id, etc
	var errorMsgStr = "";
	for (var i = 0; i < msgTab.length; i++){
		errorMsgStr += "<p id='Erreur_n"+i+"'>"+msgTab[i].msg+"</p>";
		var ariaDescribedby = $(msgTab[i].id).attr("aria-describedby");
		if(!ariaDescribedby){
			$(msgTab[i].id).attr("aria-describedby","Erreur_n"+i);
		} else {
			$(msgTab[i].id).attr("aria-describedby", ariaDescribedby + " Erreur_n"+i);
		}
		$(msgTab[i].id).attr("aria-invalid",true);
	}
	// dans le cas où plusieurs id ont été rattachés au message, on récupère juste le premier pour le focus
	var idTab = msgTab[0].id.split(",");
	if(idTab.length > 1) {
		$(idTab[0]).focus();
	} else {
		$(msgTab[0].id).focus();
	}
	return errorMsgStr;
}
function resetErrorMessages() {
	$(".error-message, .error-global-list-message, font").remove();
	$(".error-global-message").html("").addClass("nodisplay");
	$(".textField.--field-error").each(function( index ) {
		$(this).removeClass("--field-error").removeAttr("aria-invalid");
		var describedByTab = $(this).attr("aria-describedby").split(" ");
		if (describedByTab && describedByTab.length < 2){
			$(this).removeAttr("aria-describedby");
		} else {
			var describedBy = "";
			var regError = /^Erreur/;
			for (var i = 0; i < describedByTab.length; i++){
				if(!describedByTab[i].match(regError)){
					describedBy += " " + describedByTab[i];
				}
			}
			$(this).attr("aria-describedby",describedBy.trim());
		}
	});
	
}

function errorTitle(){
	var titrePage = $(document).attr('title');
	var regex = /^Erreurs/;
	// si le titre est deja precede de "Erreurs", inutile de le rajouter
	if(!titrePage.match(regex)){
		$(document).attr('title', "Erreurs - " + titrePage);
	}
}


function trapFocusArrows(element) {
  var focusableEls = element.querySelectorAll('a[href]:not([disabled]), button:not([disabled]), textarea:not([disabled]), input[type="text"]:not([disabled]), input[type="radio"]:not([disabled]), input[type="checkbox"]:not([disabled]), select:not([disabled])');
  var firstFocusableEl = focusableEls[0];  
  var lastFocusableEl = focusableEls[focusableEls.length - 1];
  var KEYCODE_TOP = 38;
  var KEYCODE_BOTT = 40;

  element.addEventListener('keydown', function(e) {
    var isTopPressed = (e.keyCode === KEYCODE_TOP);
    var isBotPressed = (e.keyCode === KEYCODE_BOTT);

   if (!isTopPressed && !isBotPressed) { 
      return; 
   }

    /* flèche top */ 
	if ( isTopPressed ){
		if (document.activeElement === firstFocusableEl) {
			lastFocusableEl.focus();
		} else {
			$(document.activeElement).parents("li").prev().find("button").focus();
		}
		e.preventDefault();
	/* flèche bas */
	} else if ( isBotPressed ) {
		if (document.activeElement === lastFocusableEl) {
			firstFocusableEl.focus();
		} else {
			$(document.activeElement).parents("li").next().find("button").focus();
		}
		e.preventDefault();
    } 
  });
}

/**
* pour mettre en forme le champ avec son accessibilite :
* @param field : champ cible
* @param msg : message d'erreur a afficher
* @param id : id du message d'erreur
* @param parentCible : pour les champs complexe comme radio, checkbox liste deroulante ou textarea
* @param cibleMsg : container html dans lequel injecter le message d'erreur. pour les duos de champs (ex : date de début + date de fin) le container peut varier selon si le message concerne un seul champ ou les deux
* @returns
*/
function formatteFieldError2020(field,msg,id,parentCible,cibleMsg){
	var fieldCustom = field;
	if(parentCible){
		fieldCustom = field.parents(parentCible);
	}
	fieldCustom.addClass("--field-error");
	var ariaDescribedBy = field.attr("aria-describedby");
	ariaDescribedBy = (ariaDescribedBy) ? id + " " + ariaDescribedBy : id; // access : l'id de l'erreur doit etre ajoute en premier
	field.attr("aria-describedby", ariaDescribedBy).attr("aria-invalid",true);
	cibleMsg = (!cibleMsg) ? ".field" : cibleMsg;
	field.parents(cibleMsg).append(displayErrorMessageWithAccess(msg,id));
}
/**
* pour mettre en forme uniqument le champ avec son accessibilite (SANS le message d'erreur) :
* NB : a utiliser dans les cas ou plusieurs champs sont rattaches au meme msg d'erreur, 
* on utilise la version complete (formatteFieldError2020()) pour le premier champ et cette version light pour les autres
* @param field : champ cible
* @param id : id du message d'erreur
* @param parentCible : pour les champs complexe comme radio, checkbox liste deroulante ou textarea
* @returns
*/
function formatteFieldErrorWithoutMsg(field,id,parentCible){
	var fieldCustom = field;
	if(parentCible){
		fieldCustom = field.parents(parentCible);
	}
	fieldCustom.addClass("--field-error");
	var ariaDescribedBy = field.attr("aria-describedby");
	ariaDescribedBy = (ariaDescribedBy) ? ariaDescribedBy + " " + id : id;
	field.attr("aria-describedby", ariaDescribedBy).attr("aria-invalid",true);
}