var aria = aria || {};

$(document).ready(function () {
  var listMenuDeroulant = $(document).find('.listbox_container');
  // On parcours la page entiere a la recherche de menu déroulant
  $.each(listMenuDeroulant, function (k, elem_menuDeroulant) {
	  // On construit le HTML du select listBox
	  buildCustomeSelect(elem_menuDeroulant);
	  
	  // On y ajoute les evenements
	  initListBox(elem_menuDeroulant)	
  })
}) 

/**
 * Construction HTML du select Customisé
 * @param elem_menuDeroulant
 * @returns
 */
function buildCustomeSelect(elem_menuDeroulant){
	var id_linkedSelected = $(elem_menuDeroulant).attr("data-select");
	var id_label = $(elem_menuDeroulant).data("label");
	
	var html_content = '<button type="button" class="btn_starter" aria-haspopup="listbox" aria-labelledby="'+id_label+'">' +
	     '<span class="btn_content"></span>'+
	     '<span class="listbox__arrow" role="presentation"><b role="presentation"></b></span>'+
	     '</button>'+
	      '<ul tabindex="-1" role="listbox" aria-labelledby="'+id_label+'" class="custom_select_ul visually-hidden">';
	         	
	
	
	this.originalSelect = document.getElementById(id_linkedSelected);
	
	// Ajout des propriétés:
	$(this.originalSelect).attr("tabindex", "-1");
	$(this.originalSelect).attr("aria-hidden", "true");
	$(this.originalSelect).addClass("sr-only");
	
	var ListOption = $(this.originalSelect).find('option');
	
	$.each(ListOption, function (key, option){
		html_content +='<li id="opt_'+id_linkedSelected+'_'+key+'" data-num="'+key+'" role="option" data-value="'+ $(option).val() +'"  >' + $(option).text() + '</li>';
	})
 	html_content +='</ul>';
	
 	$(elem_menuDeroulant).html(html_content)
}

/**
 * Fonction d'initialisation des listBoxs Customs
 * @param elem_menuDeroulant
 * @returns
 */
function initListBox(elem_menuDeroulant) {
	  var reg = new RegExp("\\s", "g");

	  // Liaison entre le custom et le select.
	  var id_linkedSelected = $(elem_menuDeroulant).attr("data-select");
	  var originalSelect = document.getElementById(id_linkedSelected);


	  var button = $(elem_menuDeroulant).children('.btn_starter')[0];
	  var listeUl = $(elem_menuDeroulant).children('.custom_select_ul')[0];
	  var placeholder = $(elem_menuDeroulant).attr("data-placeholder");
	  var exListbox = new aria.Listbox(listeUl);

	  var first_li_label = $("#" + id_linkedSelected + " option:selected").text();
	  var first_li_value = $("#" + id_linkedSelected + " option:selected").val();
	  //$(listeUl).children('li')[0].innerText;

	  var preSelectedText = "";

	  if ((placeholder === undefined || placeholder === "") &&
	    (first_li_value === undefined || first_li_value.trim() === "")) {
	    preSelectedText = "";
	  }

	  else if ((placeholder !== undefined && placeholder !== "") &&
	    (first_li_value === undefined || first_li_value.trim() === "")) {
	    preSelectedText = '<span class="listboxPlaceholder">' + placeholder + '</span>';
	  }

	  else if ((placeholder !== undefined && placeholder !== "") &&
	    (first_li_value !== undefined && first_li_value.trim() !== "")) {
	    preSelectedText = '<span class="listboxPlaceholder">' + first_li_label + '</span>';
	  }
	  
	  else if ((placeholder === undefined || placeholder === "") &&
			  (first_li_value !== undefined && first_li_value.trim() == "")) {
		  preSelectedText = '<span class="listboxPlaceholder">' + first_li_label + '</span>';
	  }

	  else if ((placeholder === undefined || placeholder === "") &&
	    (first_li_value !== undefined && first_li_value.trim() !== "")) {
	    preSelectedText = first_li_label;
	  }

	  // Important, création de l'objet aria
	  var listboxButton = new aria.ListboxButton(button, exListbox, preSelectedText, originalSelect);
	  
	}


/**
 * Objet bouton du select déclencheur
 */
aria.ListboxButton = function (button, listbox, preSelectedText, originalSelect) {
  this.button = button;
  this.listbox = listbox;
  this.preSelectedText = preSelectedText;
  this.originalSelect = originalSelect;
  this.registerEvents();
};

/**
 * Ajout des Events
 */
aria.ListboxButton.prototype.registerEvents = function () {
	this.listbox.listboxNode.addEventListener('click', this.hideListbox.bind(this));
  this.listbox.listboxNode.addEventListener('keydown', this.checkHide.bind(this));

  this.button.addEventListener('keyup', this.checkShow.bind(this));
  this.button.addEventListener('click', this.showListbox.bind(this));

  this.listbox.listboxNode.addEventListener('blur', this.hideListbox.bind(this));
  
  // On select le premier element de la liste par défaut
  if(this.preSelectedText){
	  $(this.button).find('.btn_content').html((this.preSelectedText));
  }
  
  this.listbox.setHandleFocusChange(this.onFocusChange.bind(this));
};

/**
 * Vérification des evenement clavier de navigation haut et bas
 */
aria.ListboxButton.prototype.checkShow = function (evt) {
  var key = evt.which || evt.keyCode;
  switch (key) {
    case aria.KeyCode.UP:
    case aria.KeyCode.DOWN:
      evt.preventDefault();
      this.showListbox();
      this.listbox.checkKeyPress(evt);
      break;
  }
};

/**
 * Vérification des commande de fermeture du select par clavier
 */
aria.ListboxButton.prototype.checkHide = function (evt) {
  var key = evt.which || evt.keyCode;
  switch (key) {
    case aria.KeyCode.RETURN:
    case aria.KeyCode.ESC:
      evt.preventDefault();
      this.hideListbox();
      this.button.focus();
      break;
  }
};


aria.ListboxButton.prototype.showListbox = function () {
  aria.Utils.removeClass(this.listbox.listboxNode, 'visually-hidden');
  this.button.setAttribute('aria-expanded', 'true');
  this.listbox.listboxNode.focus();
};


aria.ListboxButton.prototype.hideListbox = function () {
  aria.Utils.addClass(this.listbox.listboxNode, 'visually-hidden');
  this.button.removeAttribute('aria-expanded');
  
};

aria.ListboxButton.prototype.toggleList = function (evt) {
  if ($(this.listbox.listboxNode).hasClass('visually-hidden')) {
    this.showListbox();
  } else {
    this.hideListbox();
  }  
};


aria.ListboxButton.prototype.onFocusChange = function (focusedItem) {
 	var num_originalSelectMatch =  $(focusedItem).attr("data-num");
	// on focus le bon <option> correspondant dans le <select> natif lié.
 	$(this.originalSelect).val($(focusedItem).attr("data-value")).change();
 	var valReturn = focusedItem.innerText;
 	if(!$(focusedItem).data("value")){
 		valReturn = '<span class="listboxPlaceholder">' + focusedItem.innerText + '</span>';
 	}
	$(this.button).find('.btn_content').html(valReturn);
	
	console.log("focusedItem", focusedItem);
	console.log("focusedItem value", valReturn);
};

