$(document).ready(function(){
	if($(".androidPDF").length) {
        if(isAndroidDevice()) { 
            console.log("This device is an Android Phone"); 
            /* ne fonctionne pas en l'état
            $(".androidPDF").each(function(){
            	var url = $(this).attr("href");
            	var viewerDrive = "https://drive.google.com/viewerng/viewer?embedded=true&url=";
            	var newUrl = viewerDrive+url;
            	$(this).attr("href", newUrl);
            });
            */
        } else {
        	console.log("This device is NOT an Android Phone"); 
        }
	}
	
	//Trier table des opérations par date, libelle et montant
	$('.dropdown-operations-tri').on('change', function() {
		sortAllBy(this.value);
		$(this).parents(".dropdown-for-mobile").find(".sortSelectLabel").html($('.dropdown-operations-tri option:selected').text());
	});
	
	tableOnMobile();
	$(window).resize(function() {
		tableOnMobile();
		centerPopinContextualMenus();
	});
});


function tableOnMobile() {
	// pour le moment c'est verrouillé à prelevement et aux nouveaux tableaux. on l'implementera sur consulter au fur et a mesure des validations (= payé)
	var $table = $(".dataPrelevement, .table-version2022, .table-version2020");
	var $caption = $table.find("caption");
	var $thead = $table.find("thead");
	var $tbody = $table.find("tbody");
	var $tfoot = $table.find("tfoot");
	var $tr = $table.find("tr");
	var $tdTabVide = $table.find("td.no-operation");
	var $td = $table.find("td:not('.no-operation')");
	if($(window).width() < 769) { // seule mesure compatible avec les mediaqueries CSS + le zoom 200%
		$table.attr("role","list");
		$thead.attr("aria-hidden",true).attr("hidden",true);
		$tr.attr("role","listitem");
		$caption.attr("role","presentation");
		$tbody.attr("role","presentation");
		$tfoot.attr("role","presentation");
		$tdTabVide.attr("role","presentation");
		$td.attr("role","presentation");
		$td.each( function(){
			var $current = $(this);
			if($current.find(".data-label").length == 0){
				var label = $current.attr("data-label");
				if(label){
					$current.prepend("<span class='data-label'>"+label+"</span>");
				}
			}
		});
	} else {
		$table.removeAttr("role");
		$caption.removeAttr("role");
		$thead.removeAttr("aria-hidden").removeAttr("hidden");
		$tbody.removeAttr("role");
		$tfoot.removeAttr("role");
		$tr.removeAttr("role");
		$tdTabVide.removeAttr("role");
		$td.removeAttr("role");
		$td.find(".data-label").remove();
		
	}
}

/** **************************************************************************************** **/
/** ******** MENU CONTEXTUEL SOUS FORME DE POPIN POUR MOBILE ******************************* **/
/** **************************************************************************************** **/
// creation de la popin à la volée
function displayPopinContextualMenu(current){
	var button = $(current);
	var menu = $(current).parents('.contextual-actions').find('.contextual-nav');
	var titrePopin = "Action";
	// on encapsule le code de notre menu contextuel dans une div qui va permettre l'affichage sous forme de popin
	// point essentiel : le code doit rester là où il est situé, càd au sein du formulaire
	var popinContextualMenu = menu.wrap("<div class='popinContextualMenu block2020' id='popinContextualMenu' role='dialog' aria-labelledby='title-id'><div role='document'></div></div>");
	
	// generation de l'en-tête de la popin
	var header = "<div class=\"popinContextualMenu-header\">";
	header += "<h2 id='title-id' class='contextual-menu-title'>"+titrePopin+"</h2>";
	header += '<button type="button" class="close"><i class="icon-ic_interface_close" aria-hidden="true"></i><span class="sr-only">Fermer '+titrePopin+'</span></button>'
	header += "</div>";
	$(".popinContextualMenu > div").prepend(header);
	
	menu.addClass("show").removeClass("collapse__body--close").attr("aria-hidden",false);
	menu.find("button").attr("aria-hidden",false).attr("tabindex","0");
	button.removeClass("collapsed").attr("aria-expanded",true);
	
	// isolation visuelle + accessibilité de la popin
	isolationPopin();
	
	var popin = $(current).parents('.contextual-actions').find('.popinContextualMenu');
	
	//centrer la popin
	centerPopinContextualMenus();
	
	trapFocusMenu(document.getElementById("popinContextualMenu"));
	
	// activation des interactions des éléments spécifiques à la popin
	var closeBtn = popin.find('button.close');
	// focus sur le bouton de fermeture
	closeBtn.focus();
	// pour fermer la popin : clic sur la croix, sur le fond gris, sur la touche echap :
	closeBtn.click(function(){ closePopinContextualMenus(popin,menu); });
	$('#popinBack').click(function (e) { closePopinContextualMenus(popin,menu); });
	$(document).keydown(function(e) { if (e.keyCode == 27) { closePopinContextualMenus(popin,menu); } });
}

// calcul pour centrer la popin dans l'écran
function centerPopinContextualMenus(){
	var winWidth = window.innerWidth;
	var winHeight = window.innerHeight;
	var popinHeight = $('#popinContextualMenu').height();
	var popinWidth = $('#popinContextualMenu').width();
	
	// une zone réservée transparente empêche de cliquer sur la croix des popins en paysage sur iOS13, 
	// on agrandit donc la marge pour que la croix s'affiche sous cette zone réservée
	var margeTopBott = (isIOS13()) ? 50 : 20; // --> voir si on va en avoir besoin dans notre cas

	/*
	console.log("****** centrerPopin ******");
	console.log("WINDOW height : ", winHeight);
	console.log("WINDOW width : ", winWidth);
	console.log("POPIN height : ", popinHeight);
	console.log("POPIN width : ", popinWidth);
	console.log("****** centrerPopin ******");
	*/
	
	// positionner au centre la popin
	var positionTop = (winHeight - popinHeight)/2;
	$('#popinContextualMenu').css('top', positionTop+'px');
	
	if(winWidth > 420) {
		var positionLeft = (winWidth - popinWidth)/2;
		$('#popinContextualMenu').css('left', positionLeft+'px');
	} else {
		$('#popinContextualMenu').css('left', '10px');
	}
	
}

// réinitialisation de tout le code lorsque l'on ferme la popin : code pour l'affichage en mode popin + l'accessibilité inhérente à cet affichage
function closePopinContextualMenus(currentPopin, currentMenu){
	// remise du code à son état initial
	currentPopin.find(".popinContextualMenu-header").remove();
	currentMenu.unwrap().unwrap();
	
	// suppression des éléments d'access pour rendre la popin hermétique
	$("#popinBack").remove();
	$("body").removeClass("noscroll");
	//$('#page').removeAttr("aria-hidden");
	
	// réapplication du focus sur le bouton déclencheur 
	currentMenu.parents(".contextual-actions").find(".contextual-btn .collapse__btn").focus();
	
	// remise du code d'accessibilité transverse à son état initial
	closeContextualMenus();
}

function isolationPopin() {
	// Popin complete avec fond gris
	var blocker = 	"<div id=\"popinBack\"></div>";
	$('body').prepend(blocker);
	$("body").addClass("noscroll");
	//Rendre le fond non vocalisable par voiceover/talkback
	//$('#page').attr("aria-hidden","true"); 
	//=> je désactive car pour des raisons techniques la popin doit se trouver DANS le formulaire 
	// et donc dans la page et si je rend non vocalisable, alors la popin ne l'est plus non plus
}

// permet de rendre la tabulation hermétique dans la popin
function trapFocusMenu(element) {
	  var focusableEls = element.querySelectorAll('a[href]:not([disabled]), button:not([disabled]), textarea:not([disabled]), input[type="text"]:not([disabled]), input[type="radio"]:not([disabled]), input[type="checkbox"]:not([disabled]), select:not([disabled])');
	  var firstFocusableEl = focusableEls[0];  
	  var lastFocusableEl = focusableEls[focusableEls.length - 1];
	  var KEYCODE_TAB = 9;

	  element.addEventListener('keydown', function(e) {
	    var isTabPressed = (e.key === 'Tab' || e.keyCode === KEYCODE_TAB);

	    if (!isTabPressed) { 
	      return; 
	    }

	    if ( e.shiftKey ) /* shift + tab */ {
	      if (document.activeElement === firstFocusableEl) {
	        lastFocusableEl.focus();
	          e.preventDefault();
	        }
	      } else /* tab */ {
	      if (document.activeElement === lastFocusableEl) {
	        firstFocusableEl.focus();
	          e.preventDefault();
	        }
	      }
	  });
	}


/** **************************************************************************************** **/
/** **************************** TEST TYPE DE DEVICE / OS ********************************** **/
/** **************************************************************************************** **/

function isAndroidDevice(){
	var userAgent = navigator.userAgent.toLowerCase(); 
    var Android = userAgent.indexOf("android") > -1; 
    return Android;
}

function iOSversion() {
    if (/iP(hone|od|ad)/.test(navigator.platform)) {
        var v = (navigator.appVersion).match(/OS (\d+)_(\d+)_?(\d+)?/);
        return [parseInt(v[1], 10), parseInt(v[2], 10), parseInt(v[3] || 0, 10)];
    }
}

function isIOS13() {
	if(iOSversion() != undefined) {
		console.log("version iOS : ");
		var ver = iOSversion();
		console.log("version iOS : ", ver);
		return (ver[0] == 13) ? true : false;
	} else {
		return false;
	}
}