/*
  * @version $Revision: 1.2 $
  * @lastmodified $Date: 2020/08/20 15:40:00 $
  * Ajout noClose et onLoadFunctionName
*/

// nécessaire pour gérer le resize, surtout mobile des popins
var idContentPopinCurrent, titrePopinCurrent, displayTitleCurrent, focusApresPopinCurrent, displayCloseCurrent, pictoPopinCurrent; 
var isAlertDialogCurrent = false;
var activeConsole = true;

/********************************************************* POPIN_V3 2020 *********************************************************/
/***//* FERMETURE *//***/
function closePopinV3(){
	//suppression du fond
	$('#popinBack').remove();
	//Dans le cas d'un PDF affiche et sous IE10 et 11 uniquement, resout un probleme de page blanche - cf. jira45492
	$("#framePopin").attr('src',"about:blank");
	//suppression de la popin
	$('#modalWindow').remove();
	//Rendre le fond re vocalisable par voiceover/talkback
	$('#page').removeAttr("aria-hidden");
	$('body').removeClass("noscroll");

	$('#page').trigger(  "popinv3:close"  );
	return false;
}

/***//* Permet d'afficher la popin au centre apres l'appel du resize 
	lbpbp-6665 : deplacement du titre dans la zone scrollable
***/
function centrerPopin(){

	var myHeight = document.documentElement.clientHeight; // lbpbp-6665 : sinon la vue mobile ne prend pas la bonne hauteur
	// une zone réservée transparente empêche de cliquer sur la croix des popins en paysage sur iOS13, 
	// on agrandit donc la marge pour que la croix s'affiche sous cette zone réservée
	var margeTopBott = (isIOS13()) ? 50 : 20;
	var myPopinHeight = myHeight - margeTopBott;
	var myIframeHeight = $('#modalWindow iframe').height();
	// on récupère la hauteur du header de la popin (car 2 hauteurs possibles)
	var headerHeight = $('#modalWindow .round-banner').height();
	var titleHeight = ($("#popinTitle").length) ? $("#popinTitle").outerHeight() : 0; // lbpbp-6665 : outerHeigght pour que le padding sous le titre soit pris en compte
	var popinHeight = ((myIframeHeight + headerHeight + titleHeight) > myPopinHeight) ? myPopinHeight : (myIframeHeight + headerHeight + titleHeight);
	// passage du centrage horizontal de la popin en CSS, on désactive donc le traitement du width
	//var popinWidth = $('#modalWindow').width();


	// positionner au centre la popin
	var positionTop = (myHeight - popinHeight)/2;
	//console.log( "("+myHeight+" - "+popinHeight+")/2 = "+ positionTop);

	$('#modalWindow').css('top', positionTop+'px');
	// désormais on scroll sur la div englobante (sinon l'iframeresizer foire les calculs + permettra l'application de la correction pour ios12 si besoin)
	
	// normalement, ça devrait être la hauteur stricte du header mais il y a une scroll inutile qu'on empêche si on enleve 6px
	var headerHeightAjusted = headerHeight - 6; 
	$('#modalWindow .line').css({"maxHeight":(popinHeight - headerHeightAjusted)+'px'});
	
	if(activeConsole){
		console.log("****** centrerPopin ******");
		console.log("WINDOW height : ", myHeight);
		console.log("POPIN max height (normalement "+ myPopinHeight +") : ", $('#modalWindow').css("maxHeight"));
		console.log("POPIN height : ", $('#modalWindow').height());
		console.log("POPIN .line height : ", $('#modalWindow .line').height());
		console.log("POPIN iframe height : ", myIframeHeight);
		console.log("POPIN header height : ",$('#modalWindow .round-banner').height());
		console.log("POPIN titleHeight height : ",titleHeight);
		console.log("****** centrerPopin ******");
	}
}

/***//* Permet d'afficher la popin interne (sans iframe) au centre *//***/
function centrerPopinInt(){

	var myHeight = window.innerHeight;

	var popinHeight = $('#modalWindow .modalContent').height();

	// positionner au centre la popin
	var positionTop = (myHeight - popinHeight)/2;

	// si la mesure calculee est superieure a 20px on l'applique (pour surcharger la valeur dans la CSS et ne pas se retrouver avec une valeur negative)
	if( positionTop > 20 ) {
		$('#modalWindow').css('top', positionTop+'px');
	}
}

/* fonction de redimensionnement pour les popins IFRAME */
function resizePopinV3(){
	// on estime la hauteur max de la popin à la hauteur de la fenêtre moins un petit margin de 10px en haut et en bas
	var popinHeight = $(window).height() - 20;
	// le contenu de la popin est égal à la hauteur max de la popin moins les 100px du header de la popin
	var contentPopin = popinHeight - 100;

	/* à supprimer une fois tout stabilisé :
	 */
	//Parfois la popin n'a pas besoin d'etre redimensionnée (donc le resizedCallback n'est pas appelé) cependant elle a quand même besoin d'être centrée
	var isResized = false
	if(activeConsole){
		console.log("****** resizePopinV3 ******");
		console.log("window height : ", $(window).height());
		console.log("Popin height : ", $(window).height() - 20);
		console.log("****** resizePopinV3 ******");
	}

	if( typeof($("#framePopin").iFrameResize) == 'function' ){ 
		$("#framePopin").iFrameResize({
	        checkOrigin : false,
	        scrolling : false,
	        log:false,
	        heightCalculationMethod : 'lowestElement',
	        autoResize: true,
	        initCallback : function() {
	            window.scroll(0, 0);
	        },
	        resizedCallback: function(iframe,height,width,type){
	        	if(activeConsole) console.log("on est dans le resizedCallback")
				centrerPopin(); // on le garde mais marche pas à 100%
	        }
	    });
	} else {
		if(activeConsole) console.log("/!\\ la fonction iFrameResizer n'est pas implementee");
	}


	$('#modalWindow').css({"maxHeight":popinHeight});

	setTimeout(function() {
		// le centrerPopin a beau être appelé dans le callback, il s'active trop vite.
		// du coup, on l'appelle de nouveau en laissant un petit délai pour que les bonnes mesures soient enfin prises en compte
		centrerPopin();
	}, 500);

	return false;
}

/* fonction de redimensionnement pour les popins internes SANS iframe */
function resizePopinV3Int(value){
	// une zone réservée transparente empêche de cliquer sur la croix des popins en paysage sur iOS13, 
	// on agrandit donc la marge pour que la croix s'affiche sous cette zone réservée
	var margeTopBott = (isIOS13()) ? 70 : 40;
	var popinHeight = $(window).height() - margeTopBott;
	var popinHeaderHeight = $('#modalWindow .round-banner').height();
	$('#modalWindow').css({"maxHeight":popinHeight});
	var contentPopin = $('#modalWindow .modal-body').height();
		

    if (($('#modalWindow').length > 0) && value == 'resize') {
    	openPopinV3_int(idContentPopinCurrent, titrePopinCurrent, focusApresPopinCurrent, displayTitleCurrent, displayCloseCurrent, isAlertDialogCurrent, pictoPopinCurrent);
    }

	// on récupère la hauteur du contenu, on y ajoute les 100px du header et on les compare à la hauteur de la fenetre
	// si le contenu est plus grand que la fenêtre, on fixe la hauteur de la fenêtre en pixel pour afficher la scrollbar du contenu
	// sinon, on laisse en hauteur auto pour que la popin prenne la hauteur du contenu
	if((contentPopin + popinHeaderHeight) > popinHeight) {
		var newHeightContentPopin = popinHeight - popinHeaderHeight;
		$('#modalWindow').css({"height":popinHeight+"px"});
		$('#modalWindow .modal-body').css({"height":newHeightContentPopin+"px"});
	} else {
		$('#modalWindow').css({"height":"auto"});
	}
	
	centrerPopinInt();
	
	return false;
}

/***//* OUVERTURE *//***/
/** generation a la volee de la popin
 *  Voici les parametres possibles de l'objet param :
 *  link/urlPopin : url de la page à afficher dans l'iframe de la popin
 *  title/titrePopin : nom explicite de la popin (accessibilite), 
 *  pictoPopin : image à afficher dans le header. c'est soit la classe du picto (font icon) soit le nom du fichier .svg, 
 *  noExternClick : indique si la popin ne peut pas être fermée en cliquant sur le fond grise, 
 *  noEsc : indique si la popin ne peut pas être fermée avec la touche echap, 
 *  focusApresPopin/$nextFocus : élément IHM qui reprend le focus à la fermeture, 
 *  titleIframe : nom que l'on doit donner a l'iframe (accessibilite). si pas renseigne, on met le title a la place, 
 *  displayTitle : booleen qui indique si l'on doit afficher le titre au dessus de l'iframe ou non (en général le titre est directement dans le contenu de l'iframe), 
 *  noClose : indique que la popin ne peut pas être fermee via la croix, 
 *  onLoadIframeFunctionName : fonction JS a activer a l'affichage de la popin
 *  hideClose : booleen. si true alors on n'affiche pas la croix de fermeture de la popin
 *  onCloseFunctionName : fonction JS a activer a la fermeture de la popin
 *  isAlertDialog : booleen, par defaut on met le role "dialog" mais si à true, on remplace par "alertdialog"
 *  
 *  clairement y aurait de l'optim à faire... exemple noExternClick / noEsc / noClose / hideClose devrait dépendre d'un booleen unique
 */
function openPopinV3_ext(param) {
	//fermeture des eventuelles popins deja ouvertes
	closePopinV3();
	var hideClose = param.hideClose;
	var title = param.titrePopin;
	var titleIframe = param.titleIframe;
	var displayTitle = param.displayTitle;
	var link = param.urlPopin;
	var pictoPopin = param.pictoPopin;
	var $nextFocus = param.focusApresPopin;
	var onLoadIframeFunctionName = param.onLoadIframeFunctionName;
	var onCloseFunctionName = param.onCloseFunctionName;

	if (typeof hideClose == "undefined" || hideClose == null) {
		hideClose = false;
	}

	var reg=new RegExp("(webaccess)", "g");
	
	// maintenant, on a 2 types d'image a afficher :
	// soit le picto monochrome de la police d'ecriture des pictos
	// soit une image svg
	// /!\ selon le type d'image à afficher, le header de la popin change de taille, ce qui bouleverse tous les calculs
	var typePictoPopin = "";
	var classeVersionImg = "";
	if(pictoPopin != null && pictoPopin.match(/\.svg$/)) {
		classeVersionImg = " imgSvg";
		typePictoPopin = '<img src="../../resources/img/q4x/refonte2020/'+ pictoPopin +'" alt="" aria-hidden="true">';
	} else {
		var picto = (pictoPopin) ? pictoPopin : "icon-ic_notification_info";
		typePictoPopin = "<i class=\""+ picto +"\" aria-hidden=\"true\"></i>";
	}
	var content = "<div role=\"document\"><div class=\"header popinV3-header "+ classeVersionImg +"\">";
	content += "	<div class=\"round-banner\">"+typePictoPopin+"</div>";

	if (!hideClose) {
		content += '<button type="button" class="close" data-dismiss="modal" title="Fermer la fen&ecirc;tre '+ title +'">'+
		'<i class="icon-ic_interface_close" aria-hidden="true"></i><span class="sr-only">Fermer  la fen&ecirc;tre '+ title +'</span></button>'
	}

	content += "</div>";
	content += "<div class =\"line\">";
	if(displayTitle) {
		content += "	<h2 id=\"popinTitle\" tabindex=\"-1\">" + title.replace(reg,"") + "</h2>";
	}
	content += "	<iframe id=\"framePopin\" ";
	if(titleIframe) {
		content += "title =\"" + titleIframe + "\" ";
	} else {
		content += "title =\"" + title + "\" ";
	}
	
	content += " src=\"" + link + "\" ";
	
	content += "onload=\"trapFocusPopinV3($('#modalWindow'));"
	if(onLoadIframeFunctionName) {
		content += onLoadIframeFunctionName+"();";
	}	

	content += "\" class=\"iframe popinV3-iframe\" style=\"width: 100%; height: 500px;\">";
	content += "		<a href=\""+ link +"\" title=\"Acc&eacute;der au contenu de la popin\">Acc&eacute;der ou contenu de la popin</a>";
	content += "	</iframe>";
	//content += "</div><div tabindex='0' id='bottomPopin'>ici</div></div>"; test en cours
	content += "</div></div>";
	
	var typeDialog = (param.isAlertDialog) ? "alertdialog" : "dialog";

	// Popin complete avec fond gris
	var corps = "<div id=\"popinBack\"></div>";
	corps +=	"<div id=\"modalWindow\" role=\"" + typeDialog + "\" aria-modal=\"true\" class=\"popinV3-window popinCont\" aria-label=\"" + title + "\">";
	corps +=	"	<div class=\"modalContent\" tabindex=\"-1\">";
	corps += 		content;
	corps += 	"	</div>";
	corps += 	"</div>";

	// insertion de la popin dans la page
	$('body').prepend(corps);
	//Rendre le fond non vocalisable par voiceover/talkback
	$('#page').attr("aria-hidden","true");
	$("body").addClass("noscroll");
	
	// events de sortie de popin clic fermer, croix, echap ou clic en dehors
	if (!param.noClose) {
		$('.close').click(function(e) {
			actionsOnClosePopin($nextFocus, onCloseFunctionName);
		});
	}
	if (!param.noExternClick) {
		$('#popinBack').click(function(e) {
			actionsOnClosePopin($nextFocus, onCloseFunctionName);
		});
	}
	if (!param.noEsc) {
		$(document).keydown(function(e) {
			if (e.keyCode == 27) { actionsOnClosePopin($nextFocus, onCloseFunctionName); }
		});
		var framePopinElement = document.getElementById('framePopin');
		$(framePopinElement).load(function() {
			$(framePopinElement.contentWindow.document).keydown(function(e) {
				if (e.keyCode == 27) { actionsOnClosePopin($nextFocus, onCloseFunctionName); }
			});
		});
	}

	resizePopinV3();
	//redimensionner en cas de modification de la taille de l'ecran, rotation tablette, ...
	$(window).resize( resizePopinV3 );

	return false;
}

/* fonction de fermeture de la popin à appeler sur la croix, le fond grisé et la touche echap
 * nextFocus : element sur lequel placer le focus apres la fermeture de la popin (obligatoire)
 * onCloseFunctionName : fonction a lancer a la fermeture de la popin (optionnel)
 */
function actionsOnClosePopin(nextFocus, onCloseFunctionName) {
	if (onCloseFunctionName) {onCloseFunctionName();}
	reinitAfterClosePopinV3(); 
	nextFocus.focus(); 
	return false; 
}

// version dont le contenu est interne à la JSP
function openPopinV3_int(idContentPopin, titrePopin, focusApresPopin, displayTitle, noClose, isAlertDialog, pictoPopin) {
 	//fermeture des eventuelles popins deja ouvertes
	reinitAfterClosePopinV3();
	
	var reg=new RegExp("(webaccess)", "g");
	
	var picto = (pictoPopin) ? pictoPopin : "icon-ic_notification_info";
	
	 // maintenant, on a 2 types d'image a afficher :
    // soit le picto monochrome de la police d'ecriture des pictos
    // soit une image svg
    // /!\ selon le type d'image à afficher, le header de la popin change de taille, ce qui bouleverse tous les calculs
    var typePictoPopin = "";
    var classeVersionImg = "";
    if(picto.match(/\.svg$/)) {
        classeVersionImg = " imgSvg";
        typePictoPopin = '<img src="../../resources/img/q4x/refonte2020/'+ picto +'" alt="" aria-hidden="true">';
    } else {
        typePictoPopin = "<i class=\""+ picto +"\" aria-hidden=\"true\"></i>";
    }
	
	 var content = "<div role=\"document\"><div class=\"header popinV3-header "+ classeVersionImg +"\">";
    content += "    <div class=\"round-banner\">"+typePictoPopin+"</div>";
    if (!noClose) {
		content += '<button type="button" class="close" data-dismiss="modal" title="Fermer '+ titrePopin +'">'+
		'<i class="icon-ic_interface_close" aria-hidden="true"></i><span class="sr-only">Fermer '+ titrePopin +'</span></button>';
	}
	content += "</div>";
	content += "<div class=\"modal-body\">";
	if(displayTitle) {
		content += "	<h2 id=\"popinTitle\" tabindex=\"-1\">"+titrePopin.replace(reg,"")+"</h2>";
	}
	
	content += "<div class=\"modal-content\">";
	if(idContentPopin) {
		var idContentPopinHtml = $(idContentPopin).html();
		if(idContentPopinHtml == undefined) {
			content += "<p>Erreur lors du chargement du contenu.</p>";
		} else {
			content += idContentPopinHtml;
		}
		
	}
	content += "</div>";
	content += "</div></div>";
	
	var typeDialog = (isAlertDialog) ? "alertdialog" : "dialog";
	
	// Popin complete avec fond gris
	var corps = "<div id=\"popinBack\"></div>";
	corps +=	"<div id=\"modalWindow\" role=\"" + typeDialog + "\" aria-modal=\"true\" class=\"popinV3-window popinCont\" aria-label=\"" + titrePopin + "\">";
	corps +=	"	<div class=\"modalContent\" tabindex=\"-1\">";
	corps += 		content;
	corps += 	"	</div>";
	corps += 	"</div>";
	
	// insertion de la popin dans la page
	$('body').prepend(corps);
	//Rendre le fond non vocalisable par voiceover/talkback
	$('#page').attr("aria-hidden","true");
	$("body").addClass("noscroll");
	
	resizePopinV3Int();
	
	trapFocusPopinV3($('#modalWindow'));
	
	// events de sortie de popin clic fermer, croix, echap ou clic en dehors
	if (!noClose) {
		$('.close').click(function (e) { reinitAfterClosePopinV3(); focusApresPopin.focus(); return false; });
		$('#popinBack').click(function (e) { reinitAfterClosePopinV3(); focusApresPopin.focus(); return false; });
		$(document).keydown(function(e) { if (e.keyCode == 27) { reinitAfterClosePopinV3(); focusApresPopin.focus(); return false; } });
	}
	
	//redimensionner en cas de modification de la taille de l'ecran, rotation tablette, ...
	var resizeId;
	// pour ne lancer l'action que lorsque le resize est terminé
	$(window).resize(function() {
	    clearTimeout(resizeId);
	    resizeId = setTimeout(function() {
			resizePopinV3Int('resize');
	    }, 100);
	});
	
	return false;
}

/** 
 * Ouverture:
 * Garde pour retro-comptabilite, appele directement par certains scripts
function openPopinV3(link, title, pictoPopin, $nextFocus, titleIframe) {
	return openPopinV3_ext(link, title, pictoPopin, false, false, $nextFocus, titleIframe, false);
}
 */

function reinitAfterClosePopinV3() {
	closePopinV3();
	$("body").removeClass("noscroll");
}

function initPopinV3(current, urlPopin) {
	var param = {};
	param.urlPopin = urlPopin;
	var titrePopin = null;
	if($(current).attr("data-titrePopinV2") != undefined){
		titrePopin = $(current).attr("data-titrePopinV2");
	} else if ($(current).attr("data-titrePopin") != undefined){
		titrePopin = $(current).attr("data-titrePopin");
	}
	param.titrePopin = titrePopin;
	param.titleIframe = $(current).attr("data-titreiframe");
	if($(current).attr("data-pictopopin")){
		param.pictoPopin = $(current).attr("data-pictopopin");
	}
	param.isAlertDialog = ($(current).attr("data-alert")) ? $(current).attr("data-alert") : false;
	param.focusApresPopin = $(current);
	param.noClose = $(current).hasClass('popinV3-no-close');
	param.noExternClick = $(current).hasClass('popinV3-no-extern-click');
	param.noEsc = $(current).hasClass('popinV3-no-esc');
	
	/*if (!noEsc && !noExternClick) {
		// Cas par defaut, openPopinV3 est peut etre redefini
		openPopinV3(urlPopin, titrePopin, pictoPopin, focusApresPopin, titleIframe);
	} else {
		openPopinV3_ext(urlPopin, titrePopin, pictoPopin, noExternClick, noEsc, focusApresPopin, titleIframe, noClose);
	}*/
	openPopinV3_ext(param);
}

/** Popins edito de Q4M (infos envoyées via post message)
 * 
 * @param urlPopin : url du contenu a afficher dans l'iframe
 * @param titrePopin : titre de la popin et de l'iframe (pour l'accessibilite)
 * @returns popin HTML
 */
function initPopinEditoQ4M(urlPopin, titrePopin) {
	var param = {
		urlPopin: urlPopin,
		titrePopin: titrePopin,
		focusApresPopin: $("#ifrmQ4m")
	}
	openPopinV3_ext(param);
}

// cas où le lien peut soit ouvrir une popin soit rediriger vers une autre page
function redirigerVersPopinOuPage(event, current) {
	
	if($(current).hasClass("popinV3Check")) {
		event.preventDefault();
		initPopinV3(current, $(current).attr("href"));
	} 
    
}


/**
 * JIRA 2372 : etanchéité des popups intégrant des JSPs include ET des iframes
 * @param element (un objet JQUERY exemple : trapFocusPopinV3($('#monObjectDOM'))
 * @returns
 */
function trapFocusPopinV3(element) {
	
 	var domElementToFocus = 'span .select2-selection ,a[href]:not([disabled]), button:not([disabled]), textarea:not([disabled]), ' +
		'input[type="text"]:not([disabled]), button[type="submit"]:not([disabled]), input[type="radio"]:not([disabled]), ' +
		'input[type="submit"]:not([disabled]), input[type="checkbox"]:not([disabled]), select:not([disabled])';
	// dans les boutons radios, on doit naviguer avec les flèches et non les tabs.
	// du coup, on recupere dans notre liste que le premier et le dernier radio
	// le premier recevra le focus en marche avant (tab)
	// le dernier recevra le focus en marche arriere (shift+tab)
	var firstRadio = 'input[type="radio"]:not([disabled]):first';
	var lastRadio = 'input[type="radio"]:not([disabled]):last';
	var iframeElemID = null;
	var focusableEls = element.find(domElementToFocus);
	var elsInPopin = element.find('*');
	// on stocke les premier et dernier radios pour comparaison futur
	var firstRadioCtrl = element.find(firstRadio);
	var lastRadioCtrl = element.find(lastRadio);
	// On verifie si il s'agit d'une popup avec Iframe ou non 
	var is_a_iframe_popin = element.find('iframe').length > 0 ? true : false;
	if (is_a_iframe_popin) {
		// Dans le cas d'une popup avec Iframe, js ne sais pas distinguer un element dans l'iframe, de l'iframe elle meme
		// Il faut donc recentrer le document sur le content de l'iframe pour trouver l'element en focus.
		iframeElemID = element.find('iframe').attr('id');
		var iframeFocusableEls = $(document.getElementById(iframeElemID)).contents().find(domElementToFocus);
		var iframeEls = $(document.getElementById(iframeElemID)).contents().find('*');
		focusableEls = focusableEls.add(iframeFocusableEls);
		elsInPopin = elsInPopin.add(iframeEls);
		// on stocke les premier et dernier radios dans l'iframe pour comparaison futur
		if (!firstRadioCtrl){
			firstRadioCtrl = $(document.getElementById(iframeElemID)).contents().find(firstRadio);
		}
		if (!lastRadioCtrl){
			lastRadioCtrl = $(document.getElementById(iframeElemID)).contents().find(lastRadio);
		}
	}
	if(activeConsole){
		console.log("focusableEls", focusableEls);
		console.log('firstRadioCtrl', firstRadioCtrl);
		console.log('lastRadioCtrl', lastRadioCtrl);
	}
	// STPN-137
	// exclure les tabindex=-1 dans la variable domElementToFocus via ":not([tabindex='-1']"), 
	// ca ne fonctionne pas donc on va les retirer après coup, je ne vois plus que ca...
	var sortedFocusableEls = [];
	for (var i=0; i < focusableEls.length; i++){
		// si l'element n'a pas de tabindex, on le garde
		if(!focusableEls[i].hasAttribute("tabindex")){
			sortedFocusableEls.push(focusableEls[i]);
		} else {
		// si l'element possede un tabindex, on vérifie qu'il a bien la valeur 0 avant de l'inclure
			if($(focusableEls[i]).attr("tabindex") == 0){
				sortedFocusableEls.push(focusableEls[i]);
			}
		}
		
	}
	focusableEls = sortedFocusableEls;

	var firstFocusableEl = focusableEls[0];
	var lastFocusableEl = focusableEls[focusableEls.length - 1];

	// On ajoute le focus automatiquement sur le premier element de la popin. sauf s'il n'y a pas de croix, la, on focus le titre
	if($('.header .close').length == 0) {
		$('#popinTitle').focus();
	} else {
		firstFocusableEl.focus();
	}

	var KEYCODE_TAB = 9;
	$(element).on('keydown', function (e) {
		keyboardActionFocus(e)
	});
	
	// Si la popin contient un iframe, il faut ajouter explicitement l'event touch sur le content de l'iframe	
	if (is_a_iframe_popin) {
		$( $(document.getElementById(iframeElemID)).contents()).on('keydown', function (e) {
			keyboardActionFocus(e)
		});
	}

	function keyboardActionFocus(e){
		var is_focusable_el_in_modal = false;
		var isTabPressed = (e.key === 'Tab' || e.keyCode === KEYCODE_TAB);
		var actElem = document.activeElement;
		// Si le focus est sur un element dans l'iframe, l'element actif ne doit plus etre dans le document pere mais dans l'iframe
		if(is_a_iframe_popin && actElem === document.getElementById(iframeElemID) ){
			actElem = document.activeElement.contentWindow.document.activeElement
		}
		if (!isTabPressed) {
 			return;
		}
 		// On regarde si l'élement actif est bien porté sur un des élément focusable de la popin.
		$.each(focusableEls, function (k,v) {
 			if ( v === actElem){
  				is_focusable_el_in_modal = true;
			}
		})	
		var anElToFocus = false;
		var is_el_in_modal= false;
		if(!is_focusable_el_in_modal){
			// On regarde si l'élement actif est porté sur un des éléments de la popin.
			$.each(elsInPopin, function (k,v) {
				if((is_el_in_modal && !e.shiftkey && focusableEls.includes(v)) || (!is_el_in_modal && e.shiftKey && focusableEls.includes(v))){
					anElToFocus = true; // on vérifie qu'un élément focusable existe après ou avant l'élément actif
				}
	 			if (!is_el_in_modal && v === actElem ){ // On regarde si l'élément actif est présent dans la popin
	  				is_el_in_modal = true;
				}
			})		
		}
		// Si c'est dans la popup :
		if(is_focusable_el_in_modal){	
			// Retour en arriere clavier : shift + tab
			if ( e.shiftKey ) {
				if (actElem === firstFocusableEl) {
					lastFocusableEl.focus();
					e.preventDefault();
				} else if(focusableEls.length > 1) {
					var actElemIndex = $.inArray(actElem, focusableEls);
					var prevElement = prevFocus(actElemIndex, focusableEls);
					//if($(prevElement).isSameNode(firstRadioCtrl)){ OK sur Chrome mais fait tout planter sur FF
						$(prevElement).focus();
						e.preventDefault();
					//}
				}
 
			// Marche avant au clavier  : tab    
			} else {
				if (actElem === lastFocusableEl) {
  			    	firstFocusableEl.focus();
			    	e.preventDefault();
		        } else if(focusableEls.length > 1) {
				    var actElemIndex = $.inArray(actElem, focusableEls);
				    var nextElement = nextFocus(actElemIndex, focusableEls);
				    if(activeConsole){
					    console.log('lastRadioCtrl', lastRadioCtrl);
					    console.log('$(nextElement)', $(nextElement));
				    }
				    // if($(nextElement).isSameNode(lastRadioCtrl)){ OK sur Chrome mais fait tout planter sur FF
						$(nextElement).focus();
						e.preventDefault();
				    //}
		    	}
 			}
		}else if (!(anElToFocus && is_el_in_modal)){
			// Si  on est hors popup
			// Si on est dans la popup sur un élément non focusable et qu'aucun élément focusable ce trouve dans les éléments suivant
			// alors, on refocus sur le 1er element
 			 firstFocusableEl.focus();
			 e.preventDefault();
		} 
	}
}

// cherche le prochain élément tabulable visible
function nextFocus(indexElement, tableElements){
	var i = indexElement+1;
	do {
		var currentElement = tableElements[i];
		var visibleParent = $(currentElement).parents(".nodisplay");
	    if(visibleParent.length == 0){
		      return currentElement;
		} 
		i++;
	}
	while(i < tableElements.length);
}
// cherche l'élément précédent tabulable visible
function prevFocus(indexElement, tableElements){
	var i = indexElement-1;
	do {
		var currentElement = tableElements[i];
		var visibleParent = $(currentElement).parents(".nodisplay");
	    if(visibleParent.length == 0){
		      return currentElement;
		} 
		i--;
	}
	while(i < tableElements.length);
}


/**
 * Preparer chaque element popinV3 pour que le clic ouvre la popin
 */
$(document).ready(function() {
	// pour les popins ayant un contenu AVEC iframe
	$('.popinV3').on('click', function(e) {
		e.preventDefault();
		var urlPopin = "";
		if (this.tagName == "A") {
			urlPopin = $(this).attr("href");
		} else {
			urlPopin = $(this).attr("data-href");
		}
		initPopinV3(this, urlPopin);
	});
	// pour les popins ayant un contenu SANS iframe
	 $('.popinV3-int').on('click', function(e) {
	        e.preventDefault();
	        var idContentPopin = "";
	        if (this.tagName == "A") {
	            idContentPopin = $(this).attr("href");
	        } else {
	            idContentPopin = $(this).attr("data-href");
	        }
	        var isPopinAlert = $(this).attr("data-isPopinAlert");

			// on sauvegarde les donnees pour le resize
	        idContentPopinCurrent = idContentPopin;
	        titrePopinCurrent = $(this).attr("data-titrePopin");
	        displayTitleCurrent = $(this).attr("data-displayTitre");
	        focusApresPopinCurrent = $(this);
	        isAlertDialogCurrent = (isPopinAlert == "true") ? true : false;

	        openPopinV3_int(idContentPopinCurrent, titrePopinCurrent, focusApresPopinCurrent, displayTitleCurrent, false, isAlertDialogCurrent);

	        $("body").addClass("noscroll");
	    });
});

// en attendant de lui trouver une meilleure place
function inIframe() {
    try {
        return window.self !== window.top;
    } catch (e) {
        return true;
    }
}
