/* les listes déroulantes customisées doivent revenir à l'état natif pour les mobiles. c'est ici que ça se passe */

$(document).ready(function(){
	// active les listes custom pour DSK/TAB ou natives semi custom pour MOB
	// version select2
	if($(".liste-compte-select").length) {
		displayNativeSelect(true);
		
		$(window).resize(function() {
			displayNativeSelect(true);
	    });
	}
	// version W3C
	if($(".liste-select-w3c").length) {
		displayNativeSelect();
		
		$(window).resize(function() {
			displayNativeSelect();
		});
	}
	// active les listes natives semi custom partout
	if($(".liste-select-native").length) {
		displayNativeSelectForAllDevice();
	}

	if($(".liste-compte-select, .liste-select-w3c, .dropdown-operations-tri, .dropdown-operations-a2g-tri").length) {
		
		$('.dropdown-for-mobile .liste-compte-select, .dropdown-for-mobile .liste-select-w3c').on('change', function() {
			var newValue = $(this).find("option:selected").text();
			var selectedOption = $(this).parents(".dropdown-for-mobile").find(".sortSelectLabel");
			selectedOption.html(newValue);
			if ( $(this).val() == "" ) {
				selectedOption.addClass("default");
			} else {
				selectedOption.removeClass("default");
			}
		});
		
		var selecteursListe = '.dropdown-for-mobile .liste-compte-select, .dropdown-for-mobile .liste-select-w3c, .dropdown-for-mobile .dropdown-operations-tri, .dropdown-for-mobile .dropdown-operations-a2g-tri';
		$(selecteursListe).on('focus', function() {
			$(this).parent().addClass("isFocused");
		});
		$(selecteursListe).click(function(){
			var parent = $(this).parent();
			if(parent.hasClass("isOpen")) {
				parent.removeClass("isOpen");
			} else {
				parent.addClass("isOpen");
			}
		});
		$(selecteursListe).on('blur', function() {
			$(this).parent().removeClass("isFocused").removeClass("isOpen");
		});

	}

});

// Permet de réadapter les balises select dans les poipins selon portable et deskstop
function displayNativeSelect(isSelect2) {
    var isPopin = $("body").hasClass("contentPopin");
    if ( (!isPopin && $(window).width() < 768) || (isPopin && $(window).width() < 620) ) {
		$(".liste-compte-select, .liste-select-w3c").each( function(){
			// à cause du resize, on vérifie d'abord que les champs n'ont pas déjà leur mise en forme pour mobile
			if(!$(this).parent().hasClass('dropdown-for-mobile')) {
				if(isSelect2) {
					$(this).removeClass("select2-hidden-accessible");
				} else {
					$(".listbox_container").attr("aria-hidden","true");
					$(this).removeClass("sr-only");
				}
				$(this).removeAttr("aria-hidden").attr("tabindex","0");
				$(this).wrap("<div class='dropdown-for-mobile'></div>");
				var currentValue = $(this).find("option:selected").text();
				$(this).parent().prepend('<i class="icon-ic_interface_chevron_down" aria-hidden="true"></i>');
				$(this).parent().prepend('<span class="sortSelectLabel" aria-hidden="true">'+currentValue+'</span>');
				var selectedOption = $(this).parent().find(".sortSelectLabel");
				if ( $(this).val() == "" ) {
					selectedOption.addClass("default");
				} else {
					selectedOption.removeClass("default");
				}
				if ( $(this).is( ":disabled" ) ) {
					$(this).parents(".dropdown-for-mobile").addClass("isDisabled");
				}
			}
		});
		
	} else {
		$(".dropdown-for-mobile .liste-compte-select, .dropdown-for-mobile .liste-select-w3c").each( function(){
			if(isSelect2) {
				$(this).addClass("select2-hidden-accessible");
			} else {
				$(this).addClass("sr-only");
				$(".listbox_container").removeAttr("aria-hidden");
			}
			$(this).attr("aria-hidden",true).attr("tabindex","-1");
			$(this).parent().find(".sortSelectLabel,.icon-ic_interface_chevron_down").remove();
			$(this).unwrap("<div class='dropdown-for-mobile'></div>");
		});
	}
}
function displayNativeSelectForAllDevice() {
	$(".liste-select-native").each( function(){
		if(!$(this).parent().hasClass('dropdown-for-mobile')) {
			$(this).wrap("<div class='dropdown-for-mobile'></div>");
			var currentValue = $(this).find("option:selected").text();
			$(this).parent().prepend('<i class="icon-ic_interface_chevron_down" aria-hidden="true"></i>');
			$(this).parent().prepend('<span class="sortSelectLabel" aria-hidden="true">'+currentValue+'</span>');
			var selectedOption = $(this).parent().find(".sortSelectLabel");
			if ( $(this).val() == "" ) {
				selectedOption.addClass("default");
			} else {
				selectedOption.removeClass("default");
			}
			if ( $(this).is( ":disabled" ) ) {
				$(this).parents(".dropdown-for-mobile").addClass("isDisabled");
			}
			$(this).on('change', function() {
				var newValue = $(this).find("option:selected").text();
				var selectedOptionBis = $(this).parents(".dropdown-for-mobile").find(".sortSelectLabel");
				selectedOptionBis.html(newValue);
				if ( $(this).val() == "" ) {
					selectedOptionBis.addClass("default");
				} else {
					selectedOptionBis.removeClass("default");
				}
			});
			$(this).click(function(){
				$(this).parent().addClass("isOpen");
			});
			$(this).focus(function(){
				$(this).parent().addClass("isFocused");
			});
			$(this).blur(function(){
				$(this).parent().removeClass("isOpen").removeClass("isFocused");
			});
		}
	});
}